#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#define MAXN 310
#define INF (1e+50)

int N;
int holes[MAXN][2];
int sum[MAXN];
double minfuel[MAXN][MAXN][2];
double P;
int I;


void read_all(void);
void do_all(void);
double getminfuel(int i1, int i2, int b01);
void write_all(void);



int main(void)
{
  freopen("drain.inp", "rt", stdin);
  freopen("drain.out", "wt", stdout);
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  scanf("%d", &N);
  for (i = 0; i < N; i++) {
    scanf("%d %d", &holes[i][0], &holes[i][1]);
  }
}



void do_all(void)
{
  int i, j;
  double res;

  for (i = 0; i < N; i++) {
    for (j = i+1; j < N+1; j++) {
      sum[j] += holes[i][1];
    }
  }
  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {
      minfuel[i][j][0] = minfuel[i][j][1] = -1;
    }
  }
  P = getminfuel(0, 0, 0);
  I = 0;
  for (i = 0; i < N; i++) {
    res = getminfuel(i, i, 0);
    if (res < P) {
      P = res;
      I = i;
    }
  }
}



double getminfuel(int i1, int i2, int b01)
{
  double res, res1;
  int at, dist, sf;

  if (i1 == 0 && i2 == N-1)  return 0;
  if (minfuel[i1][i2][b01] >= -.5)  return minfuel[i1][i2][b01];
  if (b01 == 0)  at = i1;
  else  at = i2;
  res1 = res = INF;
  if (i2+1 < N) {
    dist = holes[i2+1][0]-holes[at][0];
    sf = sum[i1]+sum[N]-sum[i2+1];
    res1 = dist*sf + getminfuel(i1, i2+1, 1);
    if (res1 < res)  res = res1;
  }
  if (i1-1 >= 0) {
    dist = holes[at][0]-holes[i1-1][0];
    sf = sum[i1]+sum[N]-sum[i2+1];
    res1 = dist*sf + getminfuel(i1-1, i2, 0);
    if (res1 < res)  res = res1;
  }
  return minfuel[i1][i2][b01] = res;
}



void write_all(void)
{
  printf("%.0lf\n%d\n", P, 1+I);
}

