#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>


#define MAXN 1024

short g[MAXN][MAXN][2];
int g1[MAXN][MAXN];
char isl[MAXN][MAXN];
int deg[MAXN][2];
int t[MAXN];
int isset[MAXN];
int que[MAXN];
int ir, iw;
int N, M;
int P;
int AA;


void read_all(void);
void do_all(void);
void write_all(void);



int main(void)
{
  clock();
  freopen("work.inp", "rt", stdin);
  freopen("work.out", "wt", stdout);
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  int a, b, c;
  
  scanf("%d %d", &N, &M);
  for (i = 0; i < M; i++) {
    scanf("%d %d %d", &a, &b, &c);  a--;  b--;
    g[a][deg[a][1]][0] = b;
    g[a][deg[a][1]][1] = c;
    deg[a][1]++;
    g[b][deg[b][0]][0] = a;
    g[b][deg[b][0]][1] = c;
    deg[b][0]++;
    g1[a][b] = c;
    isl[a][b] = 1;
  }
}



void do_all(void)
{
  int i, j, k, ch, i1, i2, c1, c2;
  double tm;

  for (k = 0; k < N; k++) {
    tm = 1.*clock()/CLOCKS_PER_SEC;
    if (tm >= 1.8) {
      printf("NO SOLUTION\n");
      exit(0);
    }
    for (i = 0; i < N; i++) {
      if (isl[i][k] == 0)  continue;
      for (j = 0; j < N; j++) {
        if (isl[k][j] == 0)  continue;
        if (isl[i][j] == 0 || g1[i][k]+g1[k][j] < g1[i][j]) {
          g1[i][j] = g1[i][k]+g1[k][j];
          isl[i][j] = 1;
        }
      }
    }
  }
  for (i = 0; i < N; i++) {
    if (g1[i][i] < 0)  return;
  }
  P = 1;
  memset(isset, 0, sizeof(isset));
  t[0] = 0;
  isset[0] = 1;
  que[iw++] = 0;
  for (;;) {
    ch = 0;
    if (ir < iw) {
      i = que[ir++];
    }
    else {
      for (i = 0; i < N; i++) {
        if (isset[i] == 0)  break;
      }
      if (i >= N)  break;
    }
    isset[i] = 1;
    for (j = 0; j < N; j++) {
      if (isl[i][j] == 0)  continue;
      if (isset[j] == 0 || g1[i][j]+t[i] < t[j]) {
        t[j] = g1[i][j]+t[i];
        if (isset[j] == 0)  que[iw++] = j;
        isset[j] = 1;
      }
    }
  }
  for (i = 0; i < N; i++)  t[i] = -t[i];
  j = 0;
  for (i = 0; i < N; i++) {
    if (t[i] < t[j])  j = i;
  }
  for (i = 0; i < N; i++) {
    t[i] -= t[j];
  }
  return;
  
/*  for (;;) {
    ch = 0;
    for (k = 0; k < N; k++) {
      if (isl[k][k] && g1[k][k] < 0)  return;
      for (i = 0; i < deg[k][0]; i++) {
        i1 = g[k][i][0];
        c1 = g[k][i][1];
        for (j = 0; j < deg[i1][1]; j++) {
          i2 = g[i1][j][0];
          c2 = g[i1][j][1];
          if (isl[k][i2] == 0 || c1 + c2 <  g1[k][i2]) {
            if (isl[k][i2] == 0) {
              int a = k, b = i2, c = c1+c2;
              g[a][deg[a][1]][0] = b;
              g[a][deg[a][1]][1] = c;
              deg[a][1]++;
              g[b][deg[b][0]][0] = a;
              g[b][deg[b][0]][1] = c;
              deg[b][0]++;
              g1[a][b] = c;
              isl[a][b] = 1;
            }
            g1[k][i2] = c1 + c2;
            isl[k][i2] = 1;
            ch++;
            continue;
          }
        }
      }
    }
    AA++;
    if (AA % 100 == 0)  printf("%d %d\n", AA, ch);
    if (ch == 0)  break;
  }
  for (i = 0; i < N; i++) {
    for (j = 0; j < N; j++) {
      if (g1[i][j]+g1[j][i] < 0)  return;
    }
  }
  P = 1;*/
}



void write_all(void)
{
  int i;
  
/*  printf("%d %d\n", P, AA);*/
  if (P == 0)  printf("NO SOLUTION\n");
  else {
    for (i = 0; i < N; i++) {
      printf("%d\n", t[i]);
    }
  }
}

