#include<stdio.h>
#include<values.h>
#include<stdlib.h>
#define MAXholes 301
#define OK 1
#define NO 0

struct hole {
 int pos,debit;
};

int hnum;
hole holes[MAXholes];
//-----------
int todo;
int isOK[MAXholes];
long BestLeak=MAXLONG,CurrLeak;
int BestIndex;

void load() {
 FILE *inp=fopen("DRAIN.INP","r");
   fscanf(inp,"%d",&hnum);
   for (int i=1;i<=hnum;i++) {
      fscanf(inp,"%d",&holes[i].pos);
      fscanf(inp,"%d",&holes[i].debit);
   }
   fclose(inp);
}
//-----------------
void AddLeak(int times=1) {
   for (int t=1;t<=times;t++) {
      for (int i=1;i<=hnum;i++) {
	 if (isOK[i]==OK) continue;// this hole is OK
	 CurrLeak+=holes[i].debit;
      }
   }
}
int distance(int i1,int i2) {
   return (abs(holes[i1].pos-holes[i2].pos));
}

int LookForBetter(int id) {
 int left=id-1,right=id+1;
   do {
      if (left>0&&right<=hnum&&isOK[left]!=OK&&isOK[right]!=OK) {
	if (distance(id,left)>distance(id,right)) {
	   // right is near
	   return right;
	} else {
	   if (distance(id,left)<distance(id,right))// left is near
	      return left;
	   else {// on the same distance
	      if (holes[left].debit>holes[right].debit) // left is better
		 return left;
	      else {
		 if (holes[left].debit<holes[right].debit)// rigth is better
		    return right;
		 else {
		    left--;
		    right++;
		 }
	      }
	   }

	}
      } else {
	 if (isOK[left]==OK) left--;
	 if (isOK[right]==OK) right++;

	 if (right>hnum&&isOK[left]!=OK) return left;
	 if (left<1&&isOK[right]!=OK) return right;
      }
   } while (1);
}

void LandAt(int id) {
 int next;
   todo--;
   if (todo==0) return;
   isOK[id]=OK;
   next=LookForBetter(id);
   AddLeak(abs(holes[id].pos-holes[next].pos));
   LandAt(next);
}

void initialize() {
 int i;
   for (i=1;i<=hnum;i++) {
      isOK[i]=NO;
   }
}


void solve() {
   for (int i=1;i<=hnum;i++) {
      todo=hnum;
      initialize();
      CurrLeak=0;

      LandAt(i);
      if (CurrLeak<BestLeak) {
	 BestLeak=CurrLeak;
	 BestIndex=i;
      }
   }
}
void save() {
 FILE *out=fopen("DRAIN.OUT","w");
    fprintf(out,"%ld\n%d",BestLeak,BestIndex);
    fclose(out);
}

void main() {
   load();
   solve();
   save();
}