#include <stdio.h>

#define MAXN 16
#define MAXL 1000

int c[MAXN][MAXN], h[MAXN][MAXN], f[MAXN][MAXN];
int n, m;
int d[MAXL][4];

void dynamic(void) {
     int i, j, k, f;

     for (i = 0; i < n; ++i)
         c[i][0] = 0;
     for (i = 0; i < m; ++i)
         c[0][i] = 0;

     c[1][2] = c[2][1] = 1;

     for (i = 1; i < n; ++i)
         for (j = 1; j < m; ++j) {
             f = 0;
             for (k = 1; k < i; ++k)
                 if (c[k][j] && c[i-k-1][j]) {
                    c[i][j] = 1;
                    h[i][j] = k;
                    f = 1;
                    break;
                 }
             if (f == 0)
                for (k = 1; k < j; ++k)
                    if (c[i][k] && c[i][j-k-1]) {
                       c[i][j] = 1;
                       h[i][j] = -k;
                       break;
                    }
         }
}

void fill(int i, int j, int x, int y, int *k) {
     int t;
     
     if (x - i == 1 && y - j == 2) {
        f[i][j] = f[i+1][j] = f[i][j+1] = (*k);
        f[i][j+2] = f[i+1][j+1] = f[i+1][j+2] = (*k)+1;
        (*k) += 2;
     }
     else if (x - i == 2 && y - j == 1) {
          f[i][j] = f[i][j+1] = f[i+1][j] = (*k);
          f[i+1][j+1] = f[i+2][j] = f[i+2][j+1] = (*k)+1;
          (*k) += 2;
     }
     else {
          if (c[x-i][y-j] == 0)
             printf("Error\n");
          else {
               t = h[x-i][y-j];
               if (t < 0) {
                  t = -t;
                  fill(i, j, x, j + t, k);
                  fill(i, j + t + 1, x, y, k);
               }
               else {
                    fill(i, j, i + t, y, k);
                    fill(i + t + 1, j, x, y, k);
               }
          }
     }
}

int canfill(int x, int y, int k) {
    int i, j, fl;

    fl = 1;
    for (i = x; i < n; ++i)
        for (j = y; j < m; ++j) {
            y = 0;
            if (f[i][j] == 0) {
               fl = 0;
               f[i][j] = k;
               if (i + 1 < n) {
                  if (j > 0 && f[i+1][j] == 0 && f[i+1][j-1] == 0) {
                     f[i+1][j] = f[i+1][j-1] = k;
                     if (canfill(i, j, k+1))
                        return 1;
                     f[i+1][j] = f[i+1][j-1] = 0;
                  }                  
                  if (j + 1 < m) {
                     if (f[i][j+1] == 0 && f[i+1][j] == 0) {
                        f[i][j+1] = f[i+1][j] = k;
                        if (canfill(i, j, k+1))
                           return 1;
                        f[i][j+1] = f[i+1][j] = 0;
                     }
                     if (f[i][j+1] == 0 && f[i+1][j+1] == 0) {
                        f[i][j+1] = f[i+1][j+1] = k;
                        if (canfill(i, j, k+1))
                           return 1;
                        f[i][j+1] = f[i+1][j+1] = 0;
                     }
                     if (f[i+1][j] == 0 && f[i+1][j+1] == 0) {
                        f[i+1][j] = f[i+1][j+1] = k;
                        if (canfill(i, j, k+1))
                           return 1;
                        f[i+1][j] = f[i+1][j+1] = 0;
                     }
                  }
               }
               f[i][j] = 0;
               return 0;
            }
        }
    return fl;
}

int main(void) {
    FILE *fin, *fout;
    int i, j, k;

    fin = fopen("board.inp", "r");
    fout = fopen("board.out", "w");

    fscanf(fin, "%d %d\n", &n, &m);
//    dynamic();

    switch (n * m % 3) {
    case 0:
//         if (c[n-1][m-1] == 0)
           if (canfill(0, 0, 1) == 0)
              fprintf(fout, "0\n");
           else {
              k = n * m / 3;
//              fill(0, 0, n-1, m-1, &k);
              for (i = 0; i < n; ++i) {
                  for (j = 0; j < m; ++j)
                      if (k > 9)
                         fprintf(fout, "%3d", f[i][j]);
                      else
                          fprintf(fout, "%2d", f[i][j]);
                  fprintf(fout, "\n");
              }
         }
         break;
    case 1:
/*         if (n == 1 || m == 1) {
            if (n == m)
               fprintf(fout, "1\n1 1\n");
            else
                fprintf(fout, "0\n");
         }
         else {*/
              k = 0;
              for (i = 0; i < (n+1) / 2; ++i)
                  for (j = 0; j < (n+1) / 2; ++j)
                      if (n != m || i <= j) {
                         memset(&f, 0, sizeof(f));
                         f[i][j] = -1;
                         if (canfill(0, 0, 1)) {
                            d[k][0] = i + 1;
                            d[k][1] = j + 1;
                            ++k;
                         }
                      }
              fprintf(fout, "%d\n", k);
              for (i = 0; i < k; ++i)
                  fprintf(fout, "%d %d\n", d[i][0], d[i][1]);
//         }
         break;
    case 2:
         k = 0;
         for (i = 0; i < n / 2; ++i)
             for (j = 0; j < m / 2; ++j) {
                 memset(&f, 0, sizeof(f));
                 f[i][j] = -1;
                 f[i][j+1] = -1;
                 if (canfill(0, 0, 1)) {
                    d[k][0] = i + 1;
                    d[k][1] = j + 1;
                    d[k][2] = i + 1;
                    d[k][3] = j + 2;
                    ++k;
                 }
                 memset(&f, 0, sizeof(f));
                 f[i][j] = -1;
                 f[i+1][j] = -1;
                 if (canfill(0, 0, 1)) {
                    d[k][0] = i + 1;
                    d[k][1] = j + 1;
                    d[k][2] = i + 2;
                    d[k][3] = j + 1;
                    ++k;
                 }
             }
         fprintf(fout, "%d\n", k);
         for (i = 0; i < k; ++i)
             fprintf(fout, "%d %d %d %d\n", d[i][0], d[i][1], d[i][2], d[i][3]);
         break;
    }

    fclose(fin);
    fclose(fout);

    return 0;
}
