
 #include<fstream.h>
 #include<math.h>

 ifstream inp("ots.inp");
 ofstream out("ots.out");

 #define MAX 10000
 #define SQR(x) ((x)*(x))
 #define EPS 0.00001

 typedef struct
  {
   long x1,y1,x2,y2;
  } seg;

 seg *ots[MAX];

 long N,i,j;

 void readData()
  {
   i=0;
   ots[0]=new(seg);
   while(inp>>ots[i]->x1)
    {
     inp >>ots[i]->y1 >> ots[i]->x2 >> ots[i]->y2;
     i++;
     ots[i]=new(seg);
    };
   N=i;
  };


 long znk(long m,long x,long y)
  {
   return (long)(ots[m]->y1-ots[m]->y2)*x+(ots[m]->x2-ots[m]->x1)*y+(ots[m]->x1*ots[m]->y2-ots[m]->x2*ots[m]->y1);
  };

 double dist(long x1,long y1,long x2,long y2)
  {
   return (sqrt(SQR(x1-x2)+SQR(y1-y2)));
  };

 int zero(double r)
  {
   if (r<EPS)
    return 1;
   else
    return 0;
  };

 int cross(long n1,long n2)
  {
   if (ots[n1]->x1==ots[n2]->x1 && ots[n1]->x2==ots[n2]->x2 && ots[n1]->y1==ots[n2]->y1 && ots[n1]->y2==ots[n2]->y2)
     return 1;
   if (ots[n1]->x1==ots[n2]->x2 && ots[n1]->x2==ots[n2]->x1 && ots[n1]->y1==ots[n2]->y2 && ots[n1]->y2==ots[n2]->y1)
     return 1;
   long r1=znk(n1,ots[n2]->x1,ots[n2]->y1);
   long r2=znk(n1,ots[n2]->x2,ots[n2]->y2);
   long r3=znk(n2,ots[n1]->x1,ots[n1]->y1);
   long r4=znk(n2,ots[n1]->x2,ots[n1]->y2);
   if (r1==0 || r2==0 || r3==0 || r4==0)
    {
     if ( zero(dist(ots[n1]->x1,ots[n1]->y1,ots[n2]->x1,ots[n2]->y1)
	      +dist(ots[n2]->x1,ots[n2]->y1,ots[n1]->x2,ots[n1]->y2)
	      -dist(ots[n1]->x1,ots[n1]->y1,ots[n1]->x2,ots[n1]->y2))==1 ||
	  zero(dist(ots[n1]->x1,ots[n1]->y1,ots[n2]->x2,ots[n2]->y2)
	      +dist(ots[n2]->x2,ots[n2]->y2,ots[n1]->x2,ots[n1]->y2)
	      -dist(ots[n1]->x1,ots[n1]->y1,ots[n1]->x2,ots[n1]->y2))==1 ||
	  zero(dist(ots[n2]->x1,ots[n2]->y1,ots[n1]->x1,ots[n1]->y1)
	      +dist(ots[n1]->x1,ots[n1]->y1,ots[n2]->x2,ots[n2]->y2)
	      -dist(ots[n2]->x1,ots[n2]->y1,ots[n2]->x2,ots[n2]->y2))==1 ||
	  zero(dist(ots[n2]->x1,ots[n2]->y1,ots[n1]->x2,ots[n1]->y2)
	      +dist(ots[n1]->x2,ots[n1]->y2,ots[n2]->x2,ots[n2]->y2)
	      -dist(ots[n2]->x1,ots[n2]->y1,ots[n2]->x2,ots[n2]->y2))==1

	)

      return 1;
    }
   else
    {
     if ( ((r1>0&&r2<0)||(r1<0&&r2>0))&&((r3>0&&r4<0)||(r3<0&&r4>0)) )
      return 1;
    };
   return 0;
  };


 long doIt()
  {
   long count=0;
   for (i=0;i<N-1;i++)
    for (j=i+1;j<N;j++)
     if (cross(i,j)==1)
      count++;
   return count;
  };

 int main()
  {
   readData();
   out << doIt() << endl;
   return 0;
  };
