#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAXN 32


int N, K;
double np[MAXN][MAXN];
double nc[MAXN][MAXN];
double P;


void read_all(void);
void do_all(void);
double getnp(int n, int k);
void write_all(void);



int main(void)
{
  freopen("perm.inp", "rt", stdin);
  freopen("perm.out", "wt", stdout);
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  scanf("%d %d", &N, &K);
}



void do_all(void)
{
  int i, j;

  memset(np, -1, sizeof(np));
  for (i = 1; i <= N; i++) {
    nc[i][1] = 1;
    for (j = 2; j <= i; j++) {
      nc[i][j] = nc[i][j-1]*(1+i-j);
    }
  }
  P = getnp(N, K);
/*  N = 20;
  for (K = 1; K <= 20; K++) {
    P = getnp(N, K);
    printf("%2d %2d = %.0lf\n", N, K, P);
  }*/
}



double getnp(int n, int k)
{
  int i;
  double res;

  if (k > n)  return 0;
  if (k == n)  return 1;
  if (np[n][k] >= -.5)  return np[n][k];
  res = 0;
  for (i = 1; i <= n; i++) {
    res += nc[n][i]*getnp(n-i, k-1);
  }
  return np[n][k] = res;
}



void write_all(void)
{
  printf("%.0lf\n", P);
}

