#include <fstream>
#include <strstream>
#include <cstdlib>
#include <ctime>

using namespace std;

#define min(a,b) (((a)<(b))?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))

#define MAXN 10000

struct segment{
  double a,b,c;

  int x1, y1;
  int x2, y2;

  istream& read(istream& is) {is >> x1 >> y1 >> x2 >> y2; normalize(); abc(); return is; }
  void normalize() { if(x1 > x2){int tmp = x1; x1 = x2; x2 = tmp; tmp = y1; y1 = y2; y2 = tmp; }  }
  int crosses(segment& s);
  void abc();
};

int n = 0;
segment seg[MAXN];

int lseg[MAXN];
int lcnt = 0;
int rseg[MAXN];
int rcnt = 0;

int main(){

  srand((unsigned int)time(NULL));

  ifstream in("ots.inp");
  ofstream out("ots.out");

  int left = 50000;
  int right = 0;

  char buff[255];
  while(in.getline(buff, 255)){
    if(strlen(buff) == 0) continue;
    istrstream is(buff);
    seg[n++].read(is);
    left = min(left, seg[n-1].x1);
    right = max(right, seg[n-1].x2);
  }

  int mid = 0;
  if((right - left)/8 != 0)
    mid = (left + right)/2 + (rand()%((right-left)/4)-(right-left)/8);
  else{
    mid = 0;
  }

//  do{
    for(int i = 0; i < n; i++){
      if(seg[i].x2 < mid){
        lseg[lcnt++] = i;
      }
      else if(seg[i].x1 <= mid || seg[i].x2 == mid){
        lseg[lcnt++] = i;
        rseg[rcnt++] = i;
      }
      else{
        rseg[rcnt++] = i;
      }
    }
//  } while ((lcnt - rcnt) > n/10 || (lcnt - rcnt) < -n/10);

  int crosscnt = 0;

  for(int i = 0; i < lcnt; i++){
    for(int j = i+1; j < lcnt; j++){
      if(seg[lseg[i]].crosses(seg[lseg[j]]))
        crosscnt++;
    }
  }

  for(int i = 0; i < rcnt; i++){
    for(int j = i+1; j < rcnt; j++){
      if(seg[rseg[i]].crosses(seg[rseg[j]]))
        crosscnt++;
    }
  }

  out << crosscnt << endl;
  return 0;
}

int segment::crosses(segment& s){

  if((b*s.a - s.b*a) == 0){
    if(c*s.a - s.c*a == 0 && b*s.c - s.b*c == 0){
      if(!(x2 < s.x1 || x1 > s.x2) && !(max(y1,y2) < min(s.y1,s.y2) || min(y1,y2) > max(s.y1, s.y2) )){
        return 1;
      }
    }
    return 0;
  }
  
  double x = (b*s.c - s.b*c)/(b*s.a - s.b*a);
  double y = (a*s.c - s.a*c)/(b*s.a - s.b*a);

  if(x >= x1 && x <= x2 && x >= s.x1 && x <= s.x2){
    if((y - y1)*(y - y2) > 0 && (y - s.y1)*(y - s.y2) > 0){
      return 1;
    }
  }
  return 0;
}

void segment::abc(){

  a = y2 - y1;
  b = x1 - x2;
  c = x1*y2 - x2*y1;

}
