Const
        InFile = 'ots.inp';
        OutFile = 'ots.out';

        EPS = 0.0001;

        MAXN = 12000;

Type
        TPoint = record
                x,y : real;
        end;

        TOts = record
                p1,p2 : TPoint
        end;

Var
        FIn,FOut : text;
        a        : array [1..MAXN] of TOts;
        n,i      : longint;
        p1,p2    : TPoint;
        sum      : real;
        res      : longint;

function ss(p1,p2,p3 : TPoint) : integer;
var
        s : real;
begin
        s := (p1.x - p2.x)*(p1.y + p2.y) +
             (p2.x - p3.x)*(p2.y + p3.y) +
             (p3.x - p1.x)*(p3.y + p1.y);
        if s > EPS then
                ss := 1
        else
                if s < -EPS then
                        ss := -1
                else
                        ss := 0;
end;

function dist(p1,p2 : TPoint) : real;
begin
        dist := sqrt(sqr(p1.x - p2.x) + sqr(p1.y - p2.y));
end;

function eq(a,b : real) : boolean;
begin
        eq := abs(a-b) < EPS;
end;

function eqP(a,b  :Tpoint) : boolean;
begin
        eqP := (a.x = b.x) and (a.y = b.y);
end;

function pres(a,b : TOts) : boolean;
var
        t1,t2,t3,t4 : integer;
        s1,s2       : integer;

begin
        pres := false;

        t1 := ss(a.p1,a.p2,b.p1); t2 := ss(a.p1,a.p2,b.p2);
        t3 := ss(b.p1,b.p2,a.p1); t4 := ss(b.p1,b.p2,a.p2);

        s1 := t1*t2;
        s2 := t3*t4;
        if (s1 < 0) and (s2 < 0) then
                pres := true
        else
        if s1*s2 = 0 then
        begin
            if s1 = 0 then begin
                if (s1 = 0) and (s2 = 0) then begin
                        if (t1 = 0) and (t2 = 0) then begin
                                if a.p1.x = a.p2.x then
                                        pres := eq( dist(b.p1,b.p2), dist(b.p1,a.p1) + dist(b.p2,a.p1)) or
                                                eq( dist(b.p1,b.p2), dist(b.p1,a.p2) + dist(b.p2,a.p2))
                                else
                                        pres := (( a.p1.x >= b.p1.x) and (a.p1.x <= b.p2.x)) or
                                                (( a.p2.x >= b.p1.x) and (a.p2.x <= b.p2.x)) or
                                                (( a.p1.x <= b.p1.x) and (a.p2.x >= b.p2.x));
                        end
                        else begin
                                if t1 = 0 then
                                        pres := eqP(a.p1,b.p1) or eqP(a.p2,b.p1)
                                else
                                        pres := eqP(a.p1,b.p2) or eqP(a.p2,b.p2);
                        end;
                end
                else begin
                        if t1 = 0 then
                                if a.p1.x = a.p2.x then
                                        pres := ((b.p1.y >= a.p1.y) and ( b.p1.y <= a.p2.y)) or
                                                ((b.p1.y >= a.p2.y) and ( b.p1.y <= a.p1.y))
                                else
                                        pres := (b.p1.x >= a.p1.x) and (b.p1.x <= a.p2.x)
                        else
                                if a.p1.x = a.p2.x then
                                        pres := ((b.p2.y >= a.p1.y) and ( b.p2.y <= a.p2.y)) or
                                                ((b.p2.y >= a.p2.y) and ( b.p2.y <= a.p1.y))
                                else
                                        pres := (b.p2.x >= a.p1.x) and (b.p2.x <= a.p2.x)
                end;
            end
            else begin
                if t3 = 0 then
                                if b.p1.x = b.p2.x then
                                        pres := ((a.p1.y >= b.p1.y) and ( a.p1.y <= b.p2.y)) or
                                                ((a.p1.y >= b.p2.y) and ( a.p1.y <= b.p1.y))
                                else
                                        pres := (a.p1.x >= b.p1.x) and (a.p1.x <= b.p2.x)
                        else
                                if b.p1.x = b.p2.x then
                                        pres := ((a.p2.y >= b.p1.y) and ( a.p2.y <= b.p2.y)) or
                                                ((a.p2.y >= b.p2.y) and ( a.p2.y <= b.p1.y))
                                else
                                        pres := (a.p2.x >= b.p1.x) and (a.p2.x <= b.p2.x)
            end;
        end;
end;

procedure swap(var p1,p2 : TPoint);
var
        tmp : TPoint;
begin
        tmp := p1;
        p1 := p2;
        p2 := tmp;
end;

procedure qsort(i,j : integer);
var
        n : TOts;
        k,l : integer;
begin
        n := a[ (i+j) div 2];
        k := i; l := j;

        while k <= l do begin
                while (a[k].p1.x < n.p1.x) or
                      ((a[k].p1.x = n.p1.x) and (a[k].p2.x < n.p2.x)) do
                        inc(k);

                while (a[l].p1.x > n.p1.x) or
                      ((a[l].p1.x = n.p1.x) and (a[l].p2.x > n.p2.x)) do
                        dec(l);
                if k <= l then begin
                        swap(a[k].p1,a[l].p1);
                        swap(a[k].p2,a[l].p2);
                        inc(k); dec(l);
                end;
        end;

        if k < j then
                QSort(k,j);

        if l > i then
                QSort(i,l);
end;

procedure solve;
var
        i,j : integer;

begin
        QSort(1,N);
        res := 0;
        for i := 1 to n-1 do begin
                j := i + 1;
                while (j <= n) and (a[j].p1.x <= a[i].p2.x) do begin
                        if pres(a[i],a[j]) then
                                inc(res);
                        inc(j);

                end;
        end;
        writeln(FOut,res);
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFile);   rewrite(FOut);
        n := 0;
        while not eof(FIn) do begin
                readln(FIn,p1.x,p1.y,p2.x,p2.y);
                if p1.x > p2.x then
                        swap(p1,p2);
                inc(n);
                a[n].p1 := p1;
                a[n].p2 := p2;
        end;
        close(FIn);
        solve;
        close(FOut);
End.
