const
 ifn = 'ots.inp';
 ofn = 'ots.out';
 eps = 1E-6;
 maxn = 10000;

type
 TVec =
  record
   x, y : longint;
  end;
 Tline =
  record
   a, b : TVec;
  end;

var
 t : text;
 a : array [1 .. maxn] of TLine;

 ans, n : longint;

function eq (a, b : double) : boolean;
begin
 eq := abs (a-b) < eps;
end;

function spec (var l : Tline; x : TVec) : boolean;
var
 v, v1 : TVec;
 k : double;

begin
 with l do
  begin
   v.x := b.x - a.x;
   v.y := b.y - a.y;

   if (v.x = 0) and (v.y = 0) then
    begin
     spec := (a.x = x.x) and (a.y=x.y);
     exit;
    end;

   v1.x := x.x - a.x;
   v1.y := x.y - a.y;

   if v.x*v1.y = v.y*v1.x then
    begin
     if v.x = 0 then
      k := v1.y / v.y
     else
      k := v1.x / v.x;
      if (k + eps >= 0) and (k - eps <= 1)
       then spec := true;
    end
   else
    spec := false;
  end;
end;

function inter (var l1, l2 : TLine) : boolean;
var
 v1, v2 : TVec;
 t, t1, k, m : double;

begin
 inter := false;

 v1.x := l1.b.x - l1.a.x;
 v1.y := l1.b.y - l1.a.y;
 v2.x := l2.b.x - l2.a.x;
 v2.y := l2.b.y - l2.a.y;

 {special}
 if (v1.x = 0) and (v1.y = 0) then
  begin
   inter := spec (l2, l1.a);
   exit;
  end;

 if (v2.x = 0) and (v2.y = 0) then
  begin
   inter := spec (l1, l2.a);
   exit;
  end;

 {end special}
 t := v1.x*v2.y - v1.y*v2.x;
 if eq(t, 0) then
  begin
   inter := spec (l1, l2.a) or spec (l1, l2.b);
   exit;
  end;

 t1 := v2.y*(l2.a.x-l1.a.x) + v2.x*(l1.a.y - l2.a.y);
 k := t1 / t;

 if not eq(v2.x, 0) then
  m := (l1.a.x - l2.a.x + k*v1.x) / v2.x
 else
  m := (l1.a.y - l2.a.y + k*v1.y) / v2.y;

 if (k + eps >= 0) and (k - eps <= 1) and
    (m + eps >= 0) and (m - eps <= 1) then

    inter := true
  else
    inter := false;
end;

procedure input;
begin
 assign (t, ifn);
 reset (t);
 while not eof(t) do
  begin
   inc (n);
   with a[n] do
    readln (t, a.x, a.y, b.x, b.y);
  end;
 close (t);
end;

procedure work;
var
 i, j : longint;

begin
 for i := 1 to n do
  for j := i+1 to n do
   if inter (a[i], a[j]) then
    inc (ans);
end;

procedure output;
begin
 assign (t, ofn);
 rewrite (t);
 writeln (t, ans);
 close (t);
end;

begin
 input;
 work;
 output;
end.